import { SetValue, State } from './createState';
import { GetFunction } from './createSelector';
export declare type SetFunction = <T>(state: State<T>, value: SetValue<T>) => void;
export declare type Setter<T> = (context: {
    value: T;
    set: SetFunction;
    get: GetFunction;
    dispatch: DispatchFunction;
}) => void;
export declare type DispatchMethod<T> = (value: T) => void;
export declare type DispatchFunction = <T>(action: Action<T>, value: T) => void;
export declare type Action<T> = {
    dispatch: DispatchMethod<T>;
};
export default function createAction<T = void>(setter: Setter<T>): Action<T>;
