import { Selector } from './createSelector';
import { State } from './createState';
import { ValueRange } from './isValueInRange';
export declare type FactoryFunction<K, V> = (key: K) => V;
export declare type FactoryProperties<K> = {
    keys: Selector<Set<K>>;
};
export declare type Factory<K, V> = FactoryFunction<K, V> & FactoryProperties<K> & State<Map<K, V>>;
export default function createFactory<K, V>(fn: (key: K) => V, keyRange?: ValueRange<K> | Selector<ValueRange<K>>): Factory<K, V>;
