export declare type InitialValue<T> = T | (() => T);
export declare type GetValue<T> = T;
export declare type GetMethod<T> = () => GetValue<T>;
export declare type SetValue<T> = T | ((value: T) => T);
export declare type SetMethod<T> = (value: SetValue<T>) => void;
export declare type Observer<T> = (value: T, oldValue: T) => void;
export declare type Unobserve = () => void;
export declare type Observers<T> = Set<Observer<T>>;
export declare type ObserveMethod<T> = ((observer: Observer<T>) => Unobserve) & {
    observers: Observers<any>;
};
export declare type State<T> = {
    get: GetMethod<T>;
    set: SetMethod<T>;
    observe: ObserveMethod<T>;
};
export default function createState<T>(initialValue: InitialValue<T>): State<T>;
