import { FactoryFunction, FactoryProperties } from './createFactory';
import { Selector } from './createSelector';
import { InitialValue, State } from './createState';
import { ValueRange } from './isValueInRange';
export declare type StateFactory<K, V> = FactoryFunction<K, State<V>> & FactoryProperties<K> & State<Map<K, V>>;
export default function createStateFactory<K, V>(fn: (key: K) => InitialValue<V> | State<V>, keyRange?: ValueRange<K> | Selector<ValueRange<K>>): StateFactory<K, V>;
